#pragma once

namespace MyPicture {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	using namespace System::IO; //  DirectoryInfo

	/// <summary>
	///   Form1
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			InitializeComponent();
			//
			//TODO:   
			//

			//    " " 
			DirectoryInfo^ di; //  
			di = gcnew DirectoryInfo(Environment::GetFolderPath( 
				Environment::SpecialFolder::MyPictures)); 
			aPath = di->FullName; 
			this->Text = aPath; 
			imgList = gcnew System::Collections::Generic::List<String^>; 
			//    
			FillList(aPath);
		}

	protected:
		/// <summary>
		///    .
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::Panel^  panel1;
	private: System::Windows::Forms::Button^  button2;

	private: System::Windows::Forms::Button^  button3;
	protected: 


	private: System::Windows::Forms::Button^  button1;
	private: System::Windows::Forms::PictureBox^  pictureBox1;

	private:
		String^ aPath; //     
		//      
		System::Collections::Generic::List<String^> ^imgList; 
		int cImg; //  ( )  

		/// <summary>
		///   .
		/// </summary>
		System::ComponentModel::Container ^components;
		

#pragma region Windows Form Designer generated code
		/// <summary>
		///      -  
		///       .
		/// </summary>
		void InitializeComponent(void)
		{
			this->panel1 = (gcnew System::Windows::Forms::Panel());
			this->button2 = (gcnew System::Windows::Forms::Button());
			this->button3 = (gcnew System::Windows::Forms::Button());
			this->button1 = (gcnew System::Windows::Forms::Button());
			this->pictureBox1 = (gcnew System::Windows::Forms::PictureBox());
			this->panel1->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->pictureBox1))->BeginInit();
			this->SuspendLayout();
			// 
			// panel1
			// 
			this->panel1->Controls->Add(this->button2);
			this->panel1->Controls->Add(this->button3);
			this->panel1->Controls->Add(this->button1);
			this->panel1->Dock = System::Windows::Forms::DockStyle::Bottom;
			this->panel1->Location = System::Drawing::Point(0, 229);
			this->panel1->Name = L"panel1";
			this->panel1->Size = System::Drawing::Size(446, 33);
			this->panel1->TabIndex = 0;
			// 
			// button2
			// 
			this->button2->Location = System::Drawing::Point(162, 6);
			this->button2->Name = L"button2";
			this->button2->Size = System::Drawing::Size(49, 23);
			this->button2->TabIndex = 2;
			this->button2->Text = L"<<";
			this->button2->UseVisualStyleBackColor = true;
			this->button2->Click += gcnew System::EventHandler(this, &Form1::button3_Click);
			// 
			// button3
			// 
			this->button3->Location = System::Drawing::Point(217, 6);
			this->button3->Name = L"button3";
			this->button3->Size = System::Drawing::Size(49, 23);
			this->button3->TabIndex = 1;
			this->button3->Text = L">>";
			this->button3->UseVisualStyleBackColor = true;
			this->button3->Click += gcnew System::EventHandler(this, &Form1::button2_Click);
			// 
			// button1
			// 
			this->button1->Location = System::Drawing::Point(12, 6);
			this->button1->Name = L"button1";
			this->button1->Size = System::Drawing::Size(75, 23);
			this->button1->TabIndex = 0;
			this->button1->Text = L"";
			this->button1->UseVisualStyleBackColor = true;
			this->button1->Click += gcnew System::EventHandler(this, &Form1::button1_Click);
			// 
			// pictureBox1
			// 
			this->pictureBox1->Dock = System::Windows::Forms::DockStyle::Fill;
			this->pictureBox1->Location = System::Drawing::Point(0, 0);
			this->pictureBox1->Name = L"pictureBox1";
			this->pictureBox1->Size = System::Drawing::Size(446, 229);
			this->pictureBox1->SizeMode = System::Windows::Forms::PictureBoxSizeMode::Zoom;
			this->pictureBox1->TabIndex = 1;
			this->pictureBox1->TabStop = false;
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(446, 262);
			this->Controls->Add(this->pictureBox1);
			this->Controls->Add(this->panel1);
			this->Name = L"Form1";
			this->Text = L"- ( )";
			this->panel1->ResumeLayout(false);
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->pictureBox1))->EndInit();
			this->ResumeLayout(false);

		}
#pragma endregion
private: void ShowPicture(String^ aPicture) 
{ 
	pictureBox1->Image = gcnew Bitmap(aPath + "\\" + 
	imgList[cImg]); 
	this->Text = "-: " + aPath + "\\" + imgList[cImg]; 
	pictureBox1->Visible = true; 
} 

private: System::Boolean FillList(String^ aPath) 
{ 
	//    
	DirectoryInfo^ di = gcnew DirectoryInfo(aPath); 
	//    
	array<FileInfo^> ^fi = di->GetFiles("*.jpg"); 
	//   
	imgList->Clear(); 
	button2->Enabled = true; 
	button3->Enabled = true; 
	//     jpg-, 
	//    aPath
	for each (FileInfo^ fc in fi) 
	{ 
		imgList->Add(fc->Name); 
	} 
	this->Text = aPath; 
	if (imgList->Count == 0) 
		return false; 
	else 
	{ 
		cImg = 0; 
		ShowPicture(aPath + "\\" + imgList[cImg]); 
		//     
		button2->Enabled = false; 
		//     jpg-, 
		//     
		if (imgList->Count == 1) 
			button3->Enabled = false; 
		this->Text = "-: " + aPath + "\\" + imgList[cImg]; 
		return true; 
	} 
}
	

//    
private: System::Void button1_Click(System::Object^  sender, System::EventArgs^  e) {
	// FolderBrowserDialog     
	FolderBrowserDialog^ fb = gcnew FolderBrowserDialog(); 
	fb->Description = " ,\n" + 
		"   "; 
	fb->ShowNewFolderButton = false; 
	fb->SelectedPath = aPath; 
	//      , 
	//        
	if (fb->ShowDialog() == System::Windows::Forms::DialogResult::OK)
	{ 
		//        OK 
		aPath = fb->SelectedPath; 
		this->Text = aPath; 
		if (!FillList(fb->SelectedPath)) 
			//      
			pictureBox1->Image = nullptr; 
	}
 }

//    
private: System::Void button3_Click(System::Object^  sender, System::EventArgs^  e) {
	//    ,    
	if (!button3->Enabled) 
		button3->Enabled = true; 
	if (cImg > 0) 
	{ 
		cImg--; 
		ShowPicture(aPath + "\\" + imgList[cImg]); 
		//    
		if (cImg == 0) 
		{ 
			//     
			button2->Enabled = false; 
		} 
	}
 }

//    
private: System::Void button2_Click(System::Object^  sender, System::EventArgs^  e) {
	if (!button2->Enabled) 
		button2->Enabled = true; 
	if (cImg < imgList->Count) 
	{ 
		cImg++; 
		ShowPicture(aPath + "\\" + imgList[cImg]);
		if (cImg == imgList->Count -1) 
		{ 
			button3->Enabled = false; 
		} 
	}
 }
};
}

